PTLib Version 2.12.9

- Main Page
- Related Pages
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros Pages
Protected Attributes | List of all members
PMonitoredSocketChannel Class Reference

This class can be used to access the bundled/monitored UDP sockets using the PChannel API. More...

`#include <psockbun.h>`

Inheritance diagram for PMonitoredSocketChannel:
[legend]
Collaboration diagram for PMonitoredSocketChannel:
[legend]

## Public Member Functions
Construction
| PMonitoredSocketChannel (const PMonitoredSocketsPtr &sockets, bool shared)
| Construct a monitored socket bundle channel. More...
Overrides from class PSocket
virtual PBoolean | IsOpen () const
| Determine if the channel is currently open. More...
virtual PBoolean | Close ()
| Close the channel, shutting down the link to the data source. More...
virtual PBoolean | Read (void *buffer, PINDEX length)
| Override of PChannel functions to allow connectionless reads. More...
virtual PBoolean | Write (const void *buffer, PINDEX length)
| Override of PChannel functions to allow connectionless writes. More...
New functions for class
void | SetInterface (const PString &iface)
| Set the interface descriptor to be used for all reads/writes to this channel. More...
PString | GetInterface ()
| Get the current interface descriptor being used/. More...
bool | GetLocal (PIPSocket::Address &address, WORD &port, bool usingNAT)
| Get the local IP address and port for the currently selected interface. More...
void | SetRemote (const PIPSocket::Address &address, WORD port)
| Set the remote address/port for all Write() functions. More...
void | SetRemote (const PString &hostAndPort)
| Set the remote address/port for all Write() functions. More...
void | GetRemote (PIPSocket::Address &addr, WORD &port) const
| Get the current remote address/port for all Write() functions. More...
void | SetPromiscuous (bool flag)
| Set flag for receiving UDP data from any remote address. More...
bool | GetPromiscuous ()
| Get flag for receiving UDP data from any remote address. More...
void | GetLastReceived (PIPSocket::Address &addr, WORD &port) const
| Get the IP address and port of the last received UDP data. More...
PString | GetLastReceivedInterface () const
| Get the interface the last received UDP data was recieved on. More...
const PMonitoredSocketsPtr & | GetMonitoredSockets () const
| Get the monitored socket bundle being used by this channel. More...
Public Member Functions inherited from PChannel
PBoolean | SetErrorValues (Errors errorCode, int osError, ErrorGroup group=LastGeneralError)
| Set error values to those specified. More...
virtual Comparison | Compare (const PObject &obj) const
| Get the relative rank of the two strings. More...
virtual PINDEX | HashFunction () const
| Calculate a hash value for use in sets and dictionaries. More...
virtual PString | GetName () const
| Get the platform and I/O channel type name of the channel. More...
P_INT_PTR | GetHandle () const
| Get the integer operating system handle for the channel. More...
virtual PChannel * | GetBaseReadChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
virtual PChannel * | GetBaseWriteChannel () const
| Get the base channel of channel indirection using PIndirectChannel. More...
void | SetReadTimeout (const PTimeInterval &time)
| Set the timeout for read operations. More...
PTimeInterval | GetReadTimeout () const
| Get the timeout for read operations. More...
virtual PINDEX | GetLastReadCount () const
| Get the number of bytes read by the last Read() call. More...
virtual int | ReadChar ()
| Read a single 8 bit byte from the channel. More...
PBoolean | ReadBlock (void *buf, PINDEX len)
| Read len bytes into the buffer from the channel. More...
PString | ReadString (PINDEX len)
| Read `len` character into a string from the channel. More...
void | SetWriteTimeout (const PTimeInterval &time)
| Set the timeout for write operations to complete. More...
PTimeInterval | GetWriteTimeout () const
| Get the timeout for write operations to complete. More...
virtual PBoolean | Write (const void *buf, PINDEX len, const void *)
| Low level write to the channel with marker. More...
virtual PINDEX | GetLastWriteCount () const
| Get the number of bytes written by the last Write() call. More...
PBoolean | WriteChar (int c)
| Write a single character to the channel. More...
PBoolean | WriteString (const PString &str)
| Write a string to the channel. More...
| ~PChannel ()
| Close down the channel. More...
Errors | GetErrorCode (ErrorGroup group=NumErrorGroups) const
| Get normalised error code. More...
int | GetErrorNumber (ErrorGroup group=NumErrorGroups) const
| Get OS errro code. More...
virtual PString | GetErrorText (ErrorGroup group=NumErrorGroups) const
| Get error message description. More...
virtual bool | ReadAsync (AsyncContext &context)
| Begin an asynchronous read from channel. More...
virtual void | OnReadComplete (AsyncContext &context)
| User callback function for when a `ReadAsync()` call has completed or timed out. More...
virtual bool | WriteAsync (AsyncContext &context)
| Begin an asynchronous write from channel. More...
virtual void | OnWriteComplete (AsyncContext &context)
| User callback function for when a WriteAsync() call has completed or timed out. More...
virtual PBoolean | Shutdown (ShutdownValue option)
| Close one or both of the data streams associated with a channel. More...
virtual bool | SetLocalEcho (bool localEcho)
| Set local echo mode. More...
virtual bool | FlowControl (const void *flowData)
| Flow Control information Pass data to the channel for flowControl determination. More...
PBoolean | SetBufferSize (PINDEX newSize)
| Set the iostream buffer size for reads and writes. More...
PBoolean | SendCommandString (const PString &command)
| Send a command meta-string. More...
void | AbortCommandString ()
| Abort a command string that is in progress. More...
Public Member Functions inherited from PObject
unsigned | GetTraceContextIdentifier () const
| Get PTRACE context identifier. More...
void | SetTraceContextIdentifier (unsigned id)
void | GetTraceContextIdentifier (PObject &obj)
void | GetTraceContextIdentifier (PObject *obj)
void | SetTraceContextIdentifier (const PObject &obj)
void | SetTraceContextIdentifier (const PObject *obj)
virtual | ~PObject ()
virtual PObject * | Clone () const
| Create a copy of the class on the heap. More...
template<class CLS >
CLS * | CloneAs () const
| As for Clone() but converts to specified type. More...
virtual Comparison | CompareObjectMemoryDirect (const PObject &obj) const
| Determine the byte wise comparison of two objects. More...
bool | operator== (const PObject &obj) const
| Compare the two objects. More...
bool | operator!= (const PObject &obj) const
| Compare the two objects. More...
bool | operator< (const PObject &obj) const
| Compare the two objects. More...
bool | operator> (const PObject &obj) const
| Compare the two objects. More...
bool | operator<= (const PObject &obj) const
| Compare the two objects. More...
bool | operator>= (const PObject &obj) const
| Compare the two objects. More...
virtual const char * | GetClass (unsigned ancestor=0) const
| Get the current dynamic type of the object instance. More...
PBoolean | IsClass (const char *cls) const
virtual PBoolean | InternalIsDescendant (const char *clsName) const
| Determine if the dynamic type of the current instance is a descendent of the specified class. More...
__inline const PObject * | PTraceObjectInstance () const
virtual void | PrintOn (ostream &strm) const
| Output the contents of the object to the stream. More...
virtual void | ReadFrom (istream &strm)
| Input the contents of the object from the stream. More...

## Protected Attributes
PMonitoredSocketsPtr | socketBundle
bool | sharedBundle
PString | currentInterface
bool | promiscuousReads
PIPSocket::Address | remoteAddress
bool | closing
WORD | remotePort
PIPSocket::Address | lastReceivedAddress
WORD | lastReceivedPort
PString | lastReceivedInterface
PMutex | mutex
Protected Attributes inherited from PChannel
P_INT_PTR | os_handle
| The operating system file handle return by standard open() function. More...
Errors | lastErrorCode [NumErrorGroups+1]
| The platform independant error code. More...
int | lastErrorNumber [NumErrorGroups+1]
| The operating system error number (eg as returned by errno). More...
PINDEX | lastReadCount
| Number of byte last read by the Read() function. More...
PINDEX | lastWriteCount
| Number of byte last written by the Write() function. More...
PTimeInterval | readTimeout
| Timeout for read operations. More...
PTimeInterval | writeTimeout
| Timeout for write operations. More...
PString | channelName
| Name of channel. More...
PMutex | px_threadMutex
PXBlockType | px_lastBlockType
PThread * | px_readThread
PThread * | px_writeThread
PMutex | px_writeMutex
PThread * | px_selectThread [3]
PMutex | px_selectMutex [3]
Protected Attributes inherited from PObject
unsigned | m_traceContextIdentifier

## Additional Inherited Members
Public Types inherited from PChannel
enum | PXBlockType { PXReadBlock, PXWriteBlock, PXAcceptBlock, PXConnectBlock }
enum | Errors { NoError, NotFound, FileExists, DiskFull, AccessDenied, DeviceInUse, BadParameter, NoMemory, NotOpen, Timeout, Interrupted, BufferTooSmall, Miscellaneous, ProtocolFailure, Unavailable, NumNormalisedErrors }
| Normalised error codes. More...
enum | ErrorGroup { LastReadError, LastWriteError, LastGeneralError, NumErrorGroups }
| Error groups. More...
typedef PNotifierTemplate < PChannel::AsyncContext & > | AsyncNotifier
enum | ShutdownValue { ShutdownRead = 0, ShutdownWrite = 1, ShutdownReadAndWrite = 2 }
Static Public Member Functions inherited from PChannel
static PString | GetErrorText (Errors lastError, int osError=0)
| Get error message description. More...
static PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, Errors &lastError, int &osError)
| Convert an operating system error into platform independent error. More...
Static Public Member Functions inherited from PObject
static Comparison | InternalCompareObjectMemoryDirect (const PObject *obj1, const PObject *obj2, PINDEX size)
| Internal function caled from CompareObjectMemoryDirect() More...
static const char * | Class ()
| Get the name of the class as a C string. More...
static __inline const PObject * | PTraceObjectInstance (const char *)
static __inline const PObject * | PTraceObjectInstance (const PObject *obj)
Protected Member Functions inherited from PChannel
| PChannel (const PChannel &)
PChannel & | operator= (const PChannel &)
virtual PBoolean | ConvertOSError (P_INT_PTR libcReturnValue, ErrorGroup group=LastGeneralError)
| Convert an operating system error into platform independent error. More...
int | ReadCharWithTimeout (PTimeInterval &timeout)
| Read a character with specified timeout. More...
PBoolean | ReceiveCommandString (int nextChar, const PString &reply, PINDEX &pos, PINDEX start)
PBoolean | PXSetIOBlock (PXBlockType type, const PTimeInterval &timeout)
P_INT_PTR | GetOSHandleAsInt () const
int | PXClose ()
| PChannel ()
| Create the channel. More...
Friends inherited from PObject

## Detailed Description

This class can be used to access the bundled/monitored UDP sockets using the PChannel API.

## Constructor & Destructor Documentation

PMonitoredSocketChannel::PMonitoredSocketChannel | ( | const PMonitoredSocketsPtr & | sockets,
|  | bool | shared
| ) |  |

Construct a monitored socket bundle channel.

Parameters

  sockets | Monitored socket bundle to use in channel
  shared | Monitored socket is shared by other channels

## Member Function Documentation

virtual PBoolean PMonitoredSocketChannel::Close | ( |  | ) |
| virtual

Close the channel, shutting down the link to the data source.

Returns
  true if the channel successfully closed.

Reimplemented from PChannel.

PString PMonitoredSocketChannel::GetInterface | ( |  | ) |

Get the current interface descriptor being used/.

void PMonitoredSocketChannel::GetLastReceived | ( | PIPSocket::Address & | addr,
|  | WORD & | port
| ) |  | const
| inline

Get the IP address and port of the last received UDP data.

Parameters

  addr | Remote IP address
  port | Remote port number

References lastReceivedAddress, and lastReceivedPort.

PString PMonitoredSocketChannel::GetLastReceivedInterface | ( |  | ) | const
| inline

Get the interface the last received UDP data was recieved on.

References lastReceivedInterface.

bool PMonitoredSocketChannel::GetLocal | ( | PIPSocket::Address & | address,
|  | WORD & | port,
|  | bool | usingNAT
| ) |  |

Get the local IP address and port for the currently selected interface.

Parameters

  address | IP address of local interface
  port | Port listening on
  usingNAT | Require NAT address/port

const PMonitoredSocketsPtr& PMonitoredSocketChannel::GetMonitoredSockets | ( |  | ) | const
| inline

Get the monitored socket bundle being used by this channel.

References socketBundle.

bool PMonitoredSocketChannel::GetPromiscuous | ( |  | ) |
| inline

Get flag for receiving UDP data from any remote address.

References promiscuousReads.

void PMonitoredSocketChannel::GetRemote | ( | PIPSocket::Address & | addr,
|  | WORD & | port
| ) |  | const
| inline

Get the current remote address/port for all Write() functions.

Parameters

  addr | Remote IP address
  port | Remote port number

References remoteAddress, and remotePort.

virtual PBoolean PMonitoredSocketChannel::IsOpen | ( |  | ) | const
| virtual

Determine if the channel is currently open.

This indicates that read and write operations can be executed on the channel. For example, in the `PFile` class it returns if the file is currently open.

Returns
  true if the channel is open.

Reimplemented from PChannel.

virtual PBoolean PMonitoredSocketChannel::Read | ( | void * | buffer,
|  | PINDEX | length
| ) |  |
| virtual

Override of PChannel functions to allow connectionless reads.

Reimplemented from PChannel.

void PMonitoredSocketChannel::SetInterface | ( | const PString & | iface | ) |

Set the interface descriptor to be used for all reads/writes to this channel.

The iface parameter can be a partial descriptor eg "%eth0".

Parameters

  iface | Interface descriptor

void PMonitoredSocketChannel::SetPromiscuous | ( | bool | flag | ) |
| inline

Set flag for receiving UDP data from any remote address.

If the flag is false then data received from anything other than the configured remote address and port is ignored.

Parameters

  flag | New flag

References promiscuousReads.

void PMonitoredSocketChannel::SetRemote | ( | const PIPSocket::Address & | address,
|  | WORD | port
| ) |  |

Set the remote address/port for all Write() functions.

Parameters

  address | Remote IP address
  port | Remote port number

void PMonitoredSocketChannel::SetRemote | ( | const PString & | hostAndPort | ) |

Set the remote address/port for all Write() functions.

Parameters

  hostAndPort | String of the form host[:port]

virtual PBoolean PMonitoredSocketChannel::Write | ( | const void * | buffer,
|  | PINDEX | length
| ) |  |
| virtual

Override of PChannel functions to allow connectionless writes.

Reimplemented from PChannel.

## Member Data Documentation

bool PMonitoredSocketChannel::closing
| protected

PString PMonitoredSocketChannel::currentInterface
| protected

PIPSocket::Address PMonitoredSocketChannel::lastReceivedAddress
| protected

Referenced by GetLastReceived().

PString PMonitoredSocketChannel::lastReceivedInterface
| protected

Referenced by GetLastReceivedInterface().

WORD PMonitoredSocketChannel::lastReceivedPort
| protected

Referenced by GetLastReceived().

PMutex PMonitoredSocketChannel::mutex
| protected

bool PMonitoredSocketChannel::promiscuousReads
| protected

Referenced by GetPromiscuous(), and SetPromiscuous().

PIPSocket::Address PMonitoredSocketChannel::remoteAddress
| protected

Referenced by GetRemote().

WORD PMonitoredSocketChannel::remotePort
| protected

Referenced by GetRemote().

bool PMonitoredSocketChannel::sharedBundle
| protected

PMonitoredSocketsPtr PMonitoredSocketChannel::socketBundle
| protected

Referenced by GetMonitoredSockets().

The documentation for this class was generated from the following file:

- psockbun.h